* Implement S2S imputation
	
	clear
	save "$data\New_HFPS_HH_WAVE_ALL.dta", replace emptyok
	save "$data\Final_results_WAVE_ALL", replace emptyok
	save "$data\Final_results_WAVE_ALL_raw", replace emptyok
	
	
	
	*forvalues i=1(1)7{
forvalues i=1(1)12{
		gl wave `i'  // wave number
		dis "Wave `i'"
		foreach c in $ccc {
			di "`c'"
			glo Country_code `c'
			use "$data\03_Output\lastWave", clear
			keep if code=="`c'"
			loc lastWave1 = lastWave[1]
			if `i'<= `lastWave1' { //Run these do files only if the ith wave is available
			if (`i'~=10 | code~="MWI") & (`i'~=2 | code~="GHA")  & (`i'~=5 | code~="BFA") { // skip missing surveys, weights missing for GHA wave 2 
				do "${root}\02_Programs\04_Create_variables.do"
				do "${root}\02_Programs\05_Imputation_model.do"
				do "${root}\02_Programs\06_Export_results.do"
			}
			}	
		}
		
		
		* Merge all tabulations of outcomes in HFPS by predicted quintiles
		clear
		save "$data\Distribution_HH_WAVE$wave.dta",replace emptyok
		foreach cc in $ccc {
			cap append using "$data\\03_Output\\`cc'\Distribution_HH_`cc'_WAVE$wave.dta"
		}
		save "$data\Distribution_HH_WAVE$wave.dta",replace emptyok
		
		use "$data\Final_results_WAVE_ALL_raw.dta", clear
		append using "$data\Distribution_HH_WAVE$wave.dta"
		save "$data\Final_results_WAVE_ALL_raw", replace emptyok
		* Export to Excel
			use "$data\Distribution_HH_WAVE$wave.dta", clear
			collapse(mean)  National Urban Rural Quintile1 Quintile2 Quintile3 Quintile4 Quintile5, by(Variable)
			export excel using "$output\HFPS_Results_HH_WAVE$wave.xlsx", sheet("ALL") sheetmodify cell(A3) firstrow(varlabels)

		
		* Merge new HFPS Datasets
		clear
		save "$data\New_HFPS_HH_WAVE$wave.dta",replace emptyok
		foreach cc in $ccc {
			cap append using "$data\03_Output\HH_`cc'_New_HFPS_WAVE$wave.dta",force
		}
		save "$data\New_HFPS_HH_WAVE$wave.dta",replace emptyok

		use "$data\New_HFPS_HH_WAVE$wave.dta", clear
		gen wave2=`i'
		append using "$data\New_HFPS_HH_WAVE_ALL.dta"
		save "$data\New_HFPS_HH_WAVE_ALL.dta", replace emptyok
		
		
		* Merge GMD Datasets
		clear
		gen code=""
		save "$data\New_GMD_HH_WAVE$wave.dta",replace emptyok
		foreach cc in $ccc {
			cap append using "$data\`cc'_GMD_with_predicted_welfare.dta",force
			replace code="`cc'" if mi(code)
		}
		save "$data\New_GMD_HH_WAVE_ALL.dta",replace emptyok
		
		* Erase intermediate output
			cap erase "$data\New_HFPS_HH_WAVE$wave.dta"
			cap erase "$data\New_GMD_HH_WAVE$wave.dta"
			cap erase "$data\Distribution_HH_WAVE$wave.dta"
			cap erase "$data\HH_characteristics.dta" 
	}
	
		* Results for all waves and all countries
		use "$data\Final_results_WAVE_ALL_raw", clear
		collapse(mean)  National Urban Rural Quintile1 Quintile2 Quintile3 Quintile4 Quintile5, by(Variable)
		save "$data\Final_results_WAVE_ALL",replace emptyok
		
