* Tabulate outcomes from HFPS for different quintiles

	cap mkdir  "${root}\03_Output\\${Country_code}"
	loc wave=1
	use "$HFPSdataAfrica",clear
	keep if code=="$Country_code" & wave=="WAVE${wave}"
	drop if hid=="." | mi(hid)
	merge 1:1 hid using "$data\03_Output\HH_${Country_code}_New_HFPS_WAVE${wave}.dta"

	
	gen married=marital==1 if !mi(marital)
	gen literate =educat4>1 if !mi(educat4)
	gen head=relation==1 if !mi(relation)
	gen missing=.
	tempfile main
	save `main'

	** Global matrix for each wave
	forvalues w=1(1)`wave'{
		use  `main',clear
		
		local all_var $vlist2
		loc number_var : word count `all_var'
	
		matrix MAT_allvar_wave`w' = J(`number_var',8,.)
		local i=0
		foreach v of local all_var {
			local ++i
			qui su `v'  [aw=weight*hhsize] 
			matrix MAT_allvar_wave`w'[`i',1]=r(mean)*100
			qui su `v'  [aw=weight*hhsize] if urban==1
			matrix MAT_allvar_wave`w'[`i',2]=r(mean)*100
			qui su `v'  [aw=weight*hhsize] if urban==0
			matrix MAT_allvar_wave`w'[`i',3]=r(mean)*100	
			qui su `v'  [aw=weight*hhsize] if Quintile==1
			matrix MAT_allvar_wave`w'[`i',4]=r(mean)*100		
			qui su `v'  [aw=weight*hhsize] if Quintile==2
			matrix MAT_allvar_wave`w'[`i',5]=r(mean)*100		
			qui su `v'  [aw=weight*hhsize] if Quintile==3
			matrix MAT_allvar_wave`w'[`i',6]=r(mean)*100
			qui su `v'  [aw=weight*hhsize] if Quintile==4
			matrix MAT_allvar_wave`w'[`i',7]=r(mean)*100	
			qui su `v'  [aw=weight*hhsize] if Quintile==5
			matrix MAT_allvar_wave`w'[`i',8]=r(mean)*100
		}
		matrix rownames MAT_allvar_wave`w'=`all_var'
		matrix colnames MAT_allvar_wave`w'=National Urban Rural Q1 Q2 Q3 Q4 Q5
		mat sub_MAT_allvar_wave`w'=MAT_allvar_wave`w'[1..`i',.]
		*mat list sub_MAT_allvar_wave`w'
		exit
		
		if `w'>1 { // compute matrix of percentage change from a wage to the next
			local pre_wave=`w'-1
			matrix MAT_diff_wave`w'_wave`pre_wave'= J(`i',8,.)
			matrix rownames MAT_diff_wave`w'_wave`pre_wave'=`all_var'
			matrix colnames MAT_diff_wave`w'_wave`pre_wave'=National Urban Rural Q1 Q2 Q3 Q4 Q5
			forvalues ii=1(1)`i' {
				forvalues jj=1(1)8 {
				    if MAT_allvar_wave`pre_wave'[`ii',`jj']!=. ///
					& MAT_allvar_wave`w'[`ii',`jj']!=. {
						matrix MAT_diff_wave`w'_wave`pre_wave'[`ii',`jj']= ///
						(MAT_allvar_wave`w'[`ii',`jj']-MAT_allvar_wave`pre_wave'[`ii',`jj'])*100 ///
						/ MAT_allvar_wave`pre_wave'[`ii',`jj'] 
					}
				}
			}
		}
	}
 
 
******************************************************************************
* Export results to Excel
******************************************************************************
	* Export matrices to Excel
	*mat list  MAT_allvar_wave1

	putexcel set "${root}\03_Output\\HFPS_Results_HH_WAVE${wave}.xlsx", sheet("$Country_code") modify
	putexcel A1=("$Country_code")
	putexcel A3=matrix(MAT_allvar_wave1) , names

	* Export marix data as data 
		local names : rownames MAT_allvar_wave1
		local n_names : word count `names'
		quietly gen Variable=""
		forval i=1/`n_names' {
			local this_name = "`:word `i' of `names''"
			quietly replace Variable = "`this_name'" if _n == `i'
		}
		quietly svmat MAT_allvar_wave1

	drop if mi(Variable)
	keep code  /*survey*/ Variable MAT_allvar_wave1*
	ren MAT_allvar_wave11 National
	ren MAT_allvar_wave12 Urban
	ren MAT_allvar_wave13 Rural
	ren MAT_allvar_wave14 Quintile1
	ren MAT_allvar_wave15 Quintile2
	ren MAT_allvar_wave16 Quintile3
	ren MAT_allvar_wave17 Quintile4
	ren MAT_allvar_wave18 Quintile5
	gen wave=$wave
	save "${data}\03_Output\\${Country_code}\Distribution_HH_${Country_code}_WAVE${wave}.dta", replace

cap graph close _all
	