* Compare the means of variables between HFPS and GMD

** Install required user-written commands if not installed
	global package "heatplot" //palettes colrspace gtools
	foreach package in $package {
			capture which `package'
			if (_rc) ssc install `package'
	}

	gl wave 1
	if $wave == 1 {
	
 loc ii=0
 foreach c in $ccc {
	glo Country_code `c'
	loc ++ii
	
	import excel using "${root}\03_Output\HFPS_Results_HH_WAVE1", sheet("${Country_code}")  ///
	cellrange(K3:Z17) firstrow clear 
	keep K Mean S Z
	
	ren (K Mean S Z)(Indicator GMD GMD_Phone HFPS)
	drop if Indicator=="HH head Educat4"
	replace Indicator="Is head or spouse" if Indicator=="Individual is head or spouse"
	foreach v of varlist GMD GMD_Phone HFPS{
	  replace `v'=`v'*100 if Indicator!="Age(respondent)"  ///
	  & Indicator!="HH head age" & Indicator!="Household Size"
	} // end forval
	drop if Indicator == "Dependency ratio"

	*preserve 
		gen Country ="${Country_code}"
		ren (GMD GMD_Phone HFPS)(Mean1 Mean2 Mean3)

		reshape long Mean, i(Country Indicator) j(Survey)
		
		*tostring Survey,replace
		tempfile HH_charac_${Country_code}
		save `HH_charac_${Country_code}'
	*restore
}	


	foreach cc in $ccc {
		append using `HH_charac_`cc''
    } // end foreach
	duplicates drop
	replace Mean=. if Mean==0
	lab def Survey 1 "GMD" 2 "GMD Phone" 3 "HFPS"
	lab val Survey Survey
	gen ind=.
	replace ind=1 if Indicator=="HH head age"
	replace ind=2 if Indicator=="HH head is female"
	replace ind=3 if Indicator=="Household Head"
	replace ind=4 if Indicator=="Is head or spouse"
	replace ind=5 if Indicator=="Literate"
	replace ind=6 if Indicator=="Age(respondent)"
	replace ind=7 if Indicator=="Male"
	replace ind=8 if Indicator=="Ownership of phone"
	replace ind=9 if Indicator=="Elderly share"
	replace ind=10 if Indicator=="Children share"
	replace ind=11 if Indicator=="Urban(household)"
	replace ind=12 if Indicator=="Household Size"

	lab def Indicator 1 "HH head age" 2 "HH head is female" 3 "Household Head" ///
	4 "Is head or spouse" 5 "Literate" 6 "Age(respondent)" 7 "Male" 8 "Ownership of phone" ///
	9 "Elderly share" 10 "Children share" 11 "Urban(household)" 12 "Household Size"
	lab val  ind Indicator

	*encode Indicator,gen(ind)
	save "${data}\03_Output\HH_characteristics.dta",replace

	
	use  "${data}\03_Output\HH_characteristics.dta",clear
	order ind
	heatplot Mean i.ind i.Survey, by(Country,legend(off) note(Note: Percentage is used for non numeric indicators., size(vsmall)) ) ///
	values(format(%3.1f) mlabsize(vsmall)) color(hcl reds, reverse  intensity(.8))  aspectratio(1)   ylabel(, labsize(vsmall)) 	///
 xlabel(, labsize(tiny)) 
 	*graph export "${root}\03_Output\HH_charac.png",replace
	
	preserve
	keep if inrange(ind,8,13) 
	heatplot Mean i.ind i.Survey, by(Country,legend(off) note(Note: Percentage is used for non numeric indicators., size(vsmall)) ) ///
	values(format(%3.1f) mlabsize(vsmall)) color(hcl reds, reverse  intensity(.8))   aspectratio(1)   ylabel(, labsize(vsmall)) 	///
 xlabel(, labsize(tiny)) 
 	graph export "${root}\03_Output\HH_charac_HH.png",replace
	restore
	
	preserve
	keep if inrange(ind,1,7) 
	heatplot Mean i.ind i.Survey, by(Country,legend(off) note(Note: Percentage is used for non numeric indicators., size(vsmall)) ) ///
	values(format(%3.1f) mlabsize(vsmall)) color(hcl reds, reverse  intensity(.8))   aspectratio(1)   ylabel(, labsize(vsmall)) 	///
 xlabel(, labsize(tiny)) 
 	graph export "${root}\03_Output\HH_charac_Ind.png",replace
	restore	
	
	bysort	ind Survey : egen Mean_all=mean(Mean)
	bysort	ind Survey : egen Median_all=median(Mean)
	by ind Survey: keep if _n==1
	keep ind Survey Mean_all Median_all
	ren (Mean_all Median_all)(Mean_Median1 Mean_Median2)
	reshape long Mean_Median, i(ind Survey) j(Charac)
	lab def Charac 1 "Mean" 2 "Median"
	lab val Charac Charac
	order ind
	heatplot Mean_Median i.ind i.Survey, by(Charac,legend(off) note(Note: Percentage is used for non numeric indicators., size(small)) ) ///
	values(format(%3.1f) mlabsize(small)) color(hcl reds, reverse  intensity(.8))   aspectratio(1)   ylabel(, labsize(small)) 	///
 xlabel(, labsize(small)) 
	*graph export "${root}\03_Output\HH_charac_mean_med.png",replace
	
	preserve
	keep if inrange(ind,8,13) 
	heatplot Mean_Median i.ind i.Survey, by(Charac,legend(off) note(Note: Percentage is used for non numeric indicators., size(small)) ) ///
	values(format(%3.1f) mlabsize(small)) color(hcl reds, reverse  intensity(.8))   aspectratio(1)   ylabel(, labsize(small)) 	///
 xlabel(, labsize(small)) 
	graph export "${root}\03_Output\HH_charac_mean_med_HH.png",replace
	restore
	
	preserve
	keep if inrange(ind,1,7) 
	heatplot Mean_Median i.ind i.Survey, by(Charac,legend(off) note(Note: Percentage is used for non numeric indicators., size(small)) ) ///
	values(format(%3.1f) mlabsize(small)) color(hcl reds, reverse  intensity(.8))   aspectratio(1)   ylabel(, labsize(small)) 	///
 xlabel(, labsize(small)) 
	graph export "${root}\03_Output\HH_charac_mean_med_ind.png",replace
	restore	
	
	
	/*
	* Tabulate true and predicted quintiles in GMD (weighted)

		ta quintileGMDtrue quintileGMDhat [aw=wei] 
		loc a=r(N)
		ta quintileGMDtrue quintileGMDhat [aw=wei], matcell(m)
		mat m=m/`a'
		mat li m
	
	* Tabulate true and predicted quintiles in GMD (unweighted)
		ta quintileGMDtrue quintileGMDhat
		loc a=r(N)
		ta quintileGMDtrue quintileGMDhat, matcell(n)
		mat n=n/`a'
		mat li n
*/
	
	
	}