* Generate graphs of outcome variables by quintiles

	cls
	clear
	glo grOutput "${root}\03_Output\_Graphs\Quintile graphs"
	cap mkdir  "${root}\03_Output\_Graphs"
	cap mkdir  "$grOutput" 
	
	use "$data/Final_results_WAVE_ALL", clear
	ren Variable IndicatorName
	merge 1:1 IndicatorName using "$root\01_Input\hfps_variable_labels", keep(match) nogen
	lab var Quintile1 "Q1" // (0-20%)"
	lab var Quintile2 "Q2" // (20-40%)"
	lab var Quintile3 "Q3" // (40-60%)"
	lab var Quintile4 "Q4" // (60-80%)"
	lab var Quintile5 "Q5" // (80-100%)"
	tempfile main
	save `main'
	
	* glo vlist Copi_reduce Copi_sold Copi_used Educ_any Educ_comp Educ_mobi Educ_other Educ_teacher Educ_radio Educ_tvprog Fina_access FS_unable FS_ateless FS_atefew FS_day FS_hungry FS_skipmeal FS_ranout FS_worried Heal_rece Hous_ablepayre Inco_ToD_prew Inco_ToI_prew Inco_redremitt_prew Inco_remitt_prew Inco_FaLD_prew Inco_NfLD_prew Inco_WaLD_prew Inco_changeToD Inco_redremitt Inco_remitt Inco_FachangenLD Inco_NfchangenLD Inco_WachangenLD Labo_chang_prew Labo_chang Labo_empl Labo_farm Labo_nonfarm Labo_nonormalf Labo_notusual Labo_selfemp Labo_employee Labo_nonemployee Labo_stop Labo_stop_prew Prev_AnyStaple Safe_anysource_prew Safe_gover_prew Safe_tried_prew Safe_anysource Safe_gover Safe_tried Subj_better Subj_concer Subj_satis Subj_worse Safe_coverjob Safe_coverfood
gl vlist Inco_changeToD Labo_stop Educ_any Educ_comp Educ_tvprog FS_day Safe_gover Copi_sold

set scheme s2color

	foreach v of glo vlist {
		use `main', clear
		qui keep if IndicatorName=="`v'"
		qui su National if IndicatorName=="`v'"
		if r(N)!=0 & r(max)<100{ //if variable exists
			if IndicatorName=="`v'" gl grTitle= IndicatorDescription[1] 
			if "`v'"=="Educ_tvprog" gl grTitle "% of hh with children that watched educational TV programs"
			if "`v'"=="Educ_comp" gl grTitle "% of hh with children that completed teacher assignment"
			if "`v'"=="Educ_any" gl grTitle "% of hh with children engaged in educational activity"
			if "`v'"=="FS_day" gl grTitle "% of hh with adults didn't eat for a whole day due to lack of money"
			
			
			di "$grTitle"
			graph bar (asis) Quintile* if IndicatorName=="`v'", showyvars ytitle(Percent) yscale(range(0 100)) ylabel(#5) yscale(alt) legend(off) scheme(economist) blabel(total, format(%3.1f) size(small)) note("Note: $grTitle", size(small) span position(7))
			graph export "$grOutput\\`v'.png", replace
		}
	}	
	
	cap graph close _all
	
	