* Generate graphs of the evolution of impact since April 2020

	cls
	clear
/*
	gl root "C:\Users\Feraud Tchuisseu\Desktop\WB\Distributional impacts of Covid"
	gl GMDdata "$root\01_Input\GMD data"
	adopath ++ "$root\02_Programs"
	gl hfps "_borrar_Aug27"
	gl HFPSdata "$root\01_Input\Completed HFPS Datasets SSA\\$hfps"
	gl output "$root\03_Output"	
	
*/
*gl root "D:\AFR_Database\SSAPOV-Harmonization\Feraud\Distributional impacts of covid"
*gl root "C:\Users\WB200957\OneDrive - WBG\DEC\Github projects\Distributional Impacts of Covid"
*gl data "C:\Users\WB200957\OneDrive - WBG\DEC\DataforGithub projects\Distributional impact of Covid-19"
gl output "$root\03_Output"	
	glo grOutput "${root}\03_Output\_Graphs\Evolution of impact"
	cap mkdir  "${root}\03_Output\_Graphs"
	cap mkdir  "$grOutput" 
	
use "$data\New_HFPS_HH_WAVE_ALL.dta" , clear

encode code,gen(country)
do "$root/01_Input\hfps_variable_labels.do"

recode Quintile (1 2 = 1) (3 4 5=0), gen(b40)
* replace yyyymm=10 if yyyymm==11 //We combine Feb-2021 and Jan-2021 since we only have one survey from Feb-2011 (yyyymm=11)

gen t = yyyymm  // months since March 2020
replace t=9+month if month>=3 & year==2021
tab t month 


* Normalized weight in each months for each country
levelsof code, clean
gl clist =r(levels)
* gen weight_norm=.
su t
local maxt=r(max)

egen sumweight=sum(weight), by(country wave)
gen weight_norm=weight/sumweight 

/*foreach cc in $clist{
	 forval m=1/`maxt' {
		su weight if code=="`cc'" & t==`m'
		di "`r(N)'"
		if r(N)>0{
			gen weight_norm_`cc'_`m'=weight/r(sum) if code=="`cc'" & t==`m'
			replace weight_norm=weight_norm_`cc'_`m' if code=="`cc'" & t==`m'
			lab var weight_norm "Normalized individual weight by Quarter"				
		}
	
	 }
}
*/



*There are a lot of observations, so scatter takes a while. Doing it for just one is sufficient.
bys yyyymm b40: gen month_temp = yyyymm if _n==1

gen Inco_ToD=Inco_changeToD if wave=="WAVE1" 
replace Inco_ToD=Inco_ToD_prew if wave~="WAVE1" 
label var Inco_ToD "% of HHs that experienced decrease in total income"

gen Safe_gov=Safe_gover if wave=="WAVE1" 
replace Safe_gov=Safe_gover_prew if wave~="WAVE1" 

glo vlist Inco_ToD Copi_sold Educ_any Educ_comp FS_day  Labo_farm Labo_nonfarm Labo_notusual Safe_gov  
* gl vlist Educ_any
label define b40 0 "Top 60%" 1 "Bottom 40%"
label val b40 b40 

label define t 1 "Apr " 2 "May" 3 "Jun" 4 "Jul" 5 "Aug" 6 "Sep" 7 "Oct" 7 "Nov" 8 "Dec" 9 "Jan" 10 "Feb" 11 "Mar" 12 "Apr" 13 "May" 14 "Jun" 15 "Jul" 15 "Aug" 17 "Sep", replace 
label val t t 
label var t " "

label var FS_day "% of hh with adults didn't eat for a whole day due to lack of money"
label var Copi_sold "% of HHs sold assets such as property during the pandemic to pay for basic needs"
label var Educ_comp "% of HHs with student that completed teacher assignment"
label var Safe_gov " % of HHs received government assistance since the start of the pandemic"
local ylab_Copi_sold "Share of households"
local ylab_Educ_any "Share of households"	 
local ylab_Educ_comp "Share of households"	 
local ylab_FS_skipmeal "Share of households"
local ylab_Inco_ToD "Share of households"
local ylab_Labo_farm  "Share of households"
local ylab_Labo_nonfarm  "Share of households"
local ylab_Labo_notusual "Share of respondents"
local ylab_Safe_gov "Share of households"
local ylab_FS_day "Share of households"

local ymax_Copi_sold=0.1
local ymin_Copi_sold=0

local ymax_Educ_any=0.6
local ymin_Educ_any=0.2  

local ymax_Educ_comp=0.1
local ymin_Educ_comp=0

local ymax_FS_day=0.25
local ymin_FS_day=0

local ymax_Inco_ToD=0.8
local ymin_Inco_ToD=0.3 

local ymax_Labo_farm=0.9
local ymin_Labo_farm=0.4

local ymax_Labo_farm=0.9
local ymin_Labo_farm=0.45

local ymax_Labo_nonfarm=0.45
local ymin_Labo_nonfarm=0.25

local ymax_Labo_notusual=0.6
local ymin_Labo_notusual=0.0

local ymax_Safe_gov=0.15
local ymin_Safe_gov=0.0

local ymax_FS_day=0.25
local ymin_FS_day=0.05

egen survey=group(code wave)
drop if t>=14  

** Table 1: sample size by country and wave 
tab code wave 



foreach var in $vlist{
	preserve 
	if "`var'"=="Labo_farm" {
		drop if t>=11 // last data point extremely imprecise 
	}
	if "`var'"=="Labo_nonfarm" {
		drop if t>=13 // last data point extremely imprecise 
	}
	if "`var'"=="Labo_notusual" {
		drop if t>=12 // last data point extremely imprecise 
	}
	qui su `var'
	if r(N)!=0{
		cap drop coef_`var' 
		cap drop up_`var' 
		cap drop down_`var'
		cap drop coef_diff_`var'
		cap drop up_diff_`var'
		cap drop down_diff_`var'
		gen coef_`var' = . 
		gen up_`var' = .
		gen down_`var' = .
		gen coef_diff_`var' = .
		gen up_diff_`var' = .
		gen down_diff_`var' = .
		su t
		
		local lab: variable label `var'
		local lab "`lab'. Standard errors clustered on survey wave"
		* egen subnatid_code=group(country subnatid)
	
	
	   * reg `var' c.t##c.t##c.t#i.b40 i.country [weight = weight_norm],vce(cluster survey) // hhsize children_share elderly_share cluster(subnatid) absorb(subnatid)	
		
		
		
			
	    logit `var' c.t##c.t##c.t#i.b40  i.country [iw = weight_norm],vce(cluster survey) // hhsize children_share elderly_share cluster(subnatid) absorb(subnatid)
		*glm `var' c.t##c.t##c.t#i.b40 i.country [iw = weight_norm],vce(cluster survey) link(logit) 
		
	 
		
		margins, over(b40 c.t) asbalanced atmeans post
		local names : colnames e(b)
		foreach col of numlist 1/`=colsof(e(b))/2+1' {
			local name : word `col' of `names'
			local name=substr("`name'",2,.)
			test 1`name'=0`name'
			
		* test 1.b40#`t'.t=0.b40#`t'.t
		}
		
		
		marginsplot, ytitle("`ylab_`var''") note("Note: `lab'", size(vsmall) span position(7)) name(`var', replace)  title("") xdimension(t) plot(b40) ylab(`ymin_`var''(0.05)`ymax_`var'') scheme(s2color)
		
		graph export "${grOutput}\\`var'4.png", as(png) replace
		restore 
		
		
		
		
		
		
		*graph save "${grOutput}\\`var'", replace 
		*graph export "${grOutput}\\`var'3.png", as(png) replace
		graph close `var'
	} 
}
	
	
		exit 
	
		forvalues i = `min'(1)`max'{
			local j = `i'^2
			local k = `i'^3
			lincom `i'*_b[0.b40#c.t] + `j'*_b[0.b40#c.t#c.t] + `k'*_b[0.b40#c.t#c.t#c.t]
			replace coef_`var' = r(estimate) if t==`i' & b40==0
			replace up_`var' = r(ub) if t==`i' & b40==0
			replace down_`var' = r(lb) if t==`i' & b40==0
			lincom `i'*_b[1.b40#c.t] + `j'*_b[1.b40#c.t#c.t] + `k'*_b[1.b40#c.t#c.t#c.t]
			replace coef_`var' = r(estimate) if t==`i' & b40==1
			replace up_`var' = r(ub) if t==`i' & b40==1
			replace down_`var' = r(lb) if t==`i' & b40==1
			
			*Test differences
			lincom (`i'*_b[0.b40#c.t] + `j'*_b[0.b40#c.t#c.t] + `k'*_b[0.b40#c.t#c.t#c.t]) - (`i'*_b[1.b40#c.t] + `j'*_b[1.b40#c.t#c.t] + `k'*_b[1.b40#c.t#c.t#c.t])
			replace coef_diff_`var' = r(estimate) if t==`i'
			replace up_diff_`var' = r(ub) if t==`i'
			replace down_diff_`var' = r(lb) if t==`i'
		}

		* Rescale variables (X100) for graph
			foreach v of varlist *_`var'{
				replace `v'=`v'*100
			}
		
		* Variable label
		local lab: variable label `var'
		*di "`lab'"
		
		*Plot differences
		#delimit ;
			twoway scatter coef_diff_`var' month_temp, mcolor(navy) msize(vsmall) 			/*Coefficient plots*/
			|| 
			rcap down_diff_`var' up_diff_`var' month_temp, mcolor(navy%20) lcolor(navy%20)		/* CI*/
			graphregion(color(white)) legend(off)
			xtitle("Months since March 2020") ytitle("Bottom 40 minus Top60 (percentage points)") 
			name(`var'_diff, replace) xlabel(0(1)10)
			note("Note: `lab'", size(vsmall) span position(7))
			;
		#delimit cr
		graph export "${grOutput}\\`var'3.png", as(png) replace
		graph close `var'_diff
	}
}

