gl root="C:\Users\tians\Documents\WB\UNICEF"
gl output="$root\02.Output"
gl input="$root\01.Input"

**********************************************************************
clear 
clear matrix
clear mata
set maxvar 120000

	use "$input\_borrar.dta",clear
	drop if inlist(code, "EGY","YEM","NER","KAZ","PSE")
	drop if inlist(code, "ECU","IDN","KEN","PNG")
	drop if month==0
	recode children_number (0=0)(.=.)(1 2=1)(else=2), gen(childnum)
	drop if mi(childnum)
	merge m:1 code month year using "$input\peak_stringency"
	rename peak_month peak
	drop if _merge==2
	tab code if mi(peak)
	replace peak=5 if mi(peak)
	
	gen double weisum=100000
	bysort code wave: egen double weitot=total(weight)
	rename weight weight_orig
	gen double weight=weight_orig*weisum/weitot

	
	gen T=.
	replace T=1 if year==2020 & month-peak>=0 &month-peak<3
	replace T=2 if year==2020 & month-peak>=3 & month-peak<6
	replace T=2 if year==2021 & month+12-peak>=3 & month+12-peak<6
	replace T=3 if year==2020 & month-peak>=6 & month-peak<9
	replace T=3 if year==2021 & month+12-peak>=6 & month+12-peak<9
	replace T=4 if year==2020 & month-peak>=9 & month-peak<12
	replace T=4 if year==2021 & month+12-peak>=9 & month+12-peak<12
	replace T=5 if year==2021 & month+12-peak>=12 & month+12-peak<15
	replace T=-1 if year==2020 & month-peak<0 &month-peak>=-3
	replace T=-2 if year==2020 & month-peak<-3 &month-peak>=-6
	mdesc T
	drop if mi(T)
	drop if T<0
	drop if T==5

	//recode children_number (0=0)(.=.)(1 2=1)(else=3), gen(childnum)
	replace Inco_changeToD=Inco_ToD_prew if wave!="WAVE1"
	replace Safe_gover=Safe_gover_prew if wave!="WAVE1"
	replace Safe_anysource=Safe_anysource_prew if wave!="WAVE1"
	replace Educ_comp=. if childnum==0
	replace Educ_mobi=. if childnum==0
	
	recode urban (.=99)
	recode educat4 (.=99)
	encode code, gen(country)
	encode subnatid, gen(region)

************************************************************************
/*
	global yvar="FS_skip Educ_comp Educ_mobi Inco_changeToD Safe_gover Labo_empl"
	global xvar="i.urban i.country i.region i.educat4   c.stringency_month"
	lasso logit FS_skip $xvar [iw=weight], selection(plugin)
	logit FS_skip `e(othervars_sel)' i.T##i.childnum  [pw=weight]
	margins childnum, at(T=(1(1)4))
	marginsplot, recast(line) recastci(rarea) ytitle("Adult skipped a Meal Due to Lack of Money") xtitle (Quarter since Peak Month) legend(order(1 "No child" 2 "One or two children" 3 "Three or more children") size(small))title("Evolution of Impact on Food Security by Number of Children") graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white))
	graph export "$output\FS_skip.png", as(png) name("Graph") replace
	
	//logit FS_day $xvar [pw=weight]
	lasso logit FS_day $xvar  [iw=weight], selection(plugin)
	logit FS_day `e(othervars_sel)' i.T##i.childnum [pw=weight]
	margins childnum, at(T=(1(1)4))
	marginsplot, recast(line) recastci(rarea) ytitle("Adult Did Not Eat for a Whole Day") xtitle (Quarter since Peak Month) legend(order(1 "No child" 2 "One or two children" 3 "Three or more children") size(small))title("Evolution of Impact on Food Security by Number of Children") graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white))
	graph export "$output\FS_day.png", as(png) name("Graph") replace

	
	lasso logit Inco_changeToD $xvar  [iw=weight], selection(plugin)
	logit Inco_changeToD `e(othervars_sel)' i.T##i.childnum [pw=weight]
	//logit Inco_changeToD $xvar [pw=weight]
	margins childnum, at(T=(1(1)4))
	marginsplot, recast(line) recastci(rarea) ytitle("Experienced Decrease in Total Income") xtitle (Quarter since Peak Month) legend(order(1 "No child" 2 "One or two children" 3 "Three or more children") size(small))title("Evolution of Impact on Total Income by Number of Children") graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white))
	graph export "$output\Inco_changeToD.png", as(png) name("Graph") replace
	 
	
	lasso logit Safe_gover $xvar  [iw=weight]
	logit Safe_gover `e(othervars_sel)' i.T##i.childnum [pw=weight]
	margins childnum, at(T=(1(1)4))
	marginsplot, recast(line) recastci(rarea) ytitle("Received Government Assistance") xtitle (Quarter since Peak Month) legend(order(1 "No child" 2 "One or two children" 3 "Three or more children") size(small))title("Evolution of Impact on Government Assistance by Number of Children") graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white))
	graph export "$output\Safe_gover.png", as(png) name("Graph") replace
	*/
	logit Safe_anysource $xvar i.T##i.childnum [pw=weight]
	margins childnum, at(T=(1(1)4))
	marginsplot, recast(line) recastci(rarea) ytitle("Received Any Assistance") xtitle (Quarter since Peak Month) legend(order(1 "No child" 2 "One or two children" 3 "Three or more children") size(small))title("Evolution of Impact on Government Assistance by Number of Children") graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white))
	graph export "$output\Safe_anysource.png", as(png) name("Graph") replace
	
	e
	lasso logit Labo_empl $xvar  [iw=weight], selection(plugin)
	logit Labo_empl `e(othervars_sel)' i.T##i.childnum [pw=weight]
	//logit Labo_empl $xvar  [pw=weight]
	margins childnum, at(T=(1(1)4))
	marginsplot, recast(line) recastci(rarea) ytitle("Currently employed") xtitle ("Quarter since Peak Month") legend(order(1 "No child" 2 "One or two children" 3 "Three or more children") size(small))title("Evolution of Impact on Employment by Number of Children") graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white))
	graph export "$output\Labo_empl.png", as(png) name("Graph") replace

	
	drop if childnum==0
	lasso logit Educ_comp $xvar  [iw=weight], selection(plugin)
	logit Educ_comp `e(othervars_sel)' i.T##i.childnum [pw=weight]
	//logit Educ_comp $xvar [pw=weight]
	margins childnum, at(T=(1(1)4))
	marginsplot, recast(line) recastci(rarea) ytitle("Completed Assignment after School Closure") xtitle (Quarter since Peak Month)legend(order(1 "One or two children" 2 "Three or more children") size(small))title("Evolution of Impact on Education by Number of Children") graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white))
	graph export "$output\Educ_comp.png", as(png) name("Graph") replace
	
	lasso logit Educ_mobi $xvar  [iw=weight], selection(plugin)
	logit Educ_mobi `e(othervars_sel)' i.T##i.childnum [pw=weight]
	//logit Educ_mobi $xvar  [pw=weight]
	margins childnum, at(T=(1(1)4))
	marginsplot, recast(line) recastci(rarea) ytitle("Used mobile app for learning") xtitle ("Quarter since Peak Month") legend(order(1 "One or two children" 2 "Three or more children") size(small))title("Evolution of Impact on Education by Number of Children") graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white))
	graph export "$output\Educ_mobi.png", as(png) name("Graph") replace